<template>
    <div>
        <b-modal
            id="todo-modal"
            ref="todo-modal"
            :title="title"
        >
            <b-form>
                <b-form-group>
                    <b-form-input
                        placeholder="Başlık"
                        id="name-input"
                        v-model="form.content"
                    ></b-form-input>
                </b-form-group>

                <b-form-group>
                    <b-form-select
                        id="priority-input"
                        v-model="form.priority"
                        :options="priorityOptions"
                        value-field="item"
                        text-field="name"
                    ></b-form-select>
                </b-form-group>

            </b-form>

            <template #modal-footer>
                <b-button class="float-right" @click="close()">İptal</b-button>
                <b-button variant="primary" class="float-right" @click="mode === 'create' ? save() : update()">Kaydet
                </b-button>
            </template>

        </b-modal>
    </div>
</template>

<script>
import {mapActions} from "vuex";

export default {
    name: "CreateTodo",
    props: {
        todo: {
            type: Object
        },
        mode: {
            type: String
        }
    },
    computed: {
        title() {
            return this.mode === 'create' ? 'Yeni Oluştur' : 'Düzenle'
        }
    },
    data() {
        return {
            form: {
                content: '',
                priority: 'normal'
            },
            priorityOptions: [
                {item: 'low', name: 'Düşük'},
                {item: 'normal', name: 'Normal'},
                {item: 'high', name: 'Yüksek'}
            ]
        }
    },
    watch: {
        // A tricky solution to not creating new modal for update and create actions
        mode() {
            if (this.mode === 'create') {
                this.clear()
            }
        },
        todo() {
            this.form = this.todo
        }
    },
    methods: {
        ...mapActions('todo', [
            'createTodo',
            'updateTodo'
        ]),
        async save() {
            const payload = {
                content: this.form.content,
                priority: this.form.priority
            }
            await this.createTodo(payload)
            this.close()
            this.refresh()
        },
        async update() {
            await this.updateTodo({
                id: this.todo.id,
                payload: {
                    content: this.form.content,
                    priority: this.form.priority
                }
            })
            this.close()
            this.refresh()
        },
        refresh() {
            this.$root.$emit('bv::refresh::table', 'todo-table')
        },
        close() {
            this.$bvModal.hide('todo-modal')
        },
        // makes models default
        clear() {
            this.form = {
                content: '',
                priority: 'normal'
            }
        }
    }
}
</script>

<style scoped>

</style>
